VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "EventHandler"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'------------------------------------------<BEGINING of Alphabetiser.cls>--------------------------------------
Dim SortClasses As RoseContextMenuItem
Dim NamesArray() As String

Option Compare Text
Option Explicit

Public Sub SelectionSortStrings(ListArray() As String, _
        Optional ByVal bAscending As Boolean = True, _
        Optional ByVal bCaseSensitive As Boolean = False)
    
    Dim sSmallest       As String
    Dim lSmallest       As Long
    Dim lCount1         As Long
    Dim lCount2         As Long
    Dim lMin            As Long
    Dim lMax            As Long
    Dim lCompareType    As Long
    Dim lOrder          As Long
    
    lMin = LBound(ListArray)
    lMax = UBound(ListArray)
    
    If lMin = lMax Then
        Exit Sub
    End If
    
    ' Order Ascending or Descending?
    lOrder = IIf(bAscending, -1, 1)
    
    ' Case sensitive search or not?
    lCompareType = IIf(bCaseSensitive, vbBinaryCompare, vbTextCompare)
    
    ' Loop through array swapping the smallest\largest (determined by lOrder)
    ' item with the current item
    For lCount1 = lMin To lMax - 1
        sSmallest = ListArray(lCount1)
        lSmallest = lCount1
        
        ' Find the smallest\largest item in the array
        For lCount2 = lCount1 + 1 To lMax
          If StrComp(ListArray(lCount2), sSmallest, lCompareType) = lOrder Then
            sSmallest = ListArray(lCount2)
            lSmallest = lCount2
          End If
        Next
        
        ' Just swapping them, even with itself,
        ' as it is generally quicker to do this than test first
        ' each time if it is the smallest with a test like:
        ' If lSmallest <> lCount1 Then
        ListArray(lSmallest) = ListArray(lCount1)
        ListArray(lCount1) = sSmallest
    Next
End Sub

Public Function OnEnableContextMenuItems(RoseApp As RoseApplication, _
        MenuItem As RoseContextMenuItemType) As Boolean
     If MenuItem = rsPackage Then
      
        If RoseApp.CurrentModel.GetSelectedCategories.Count = 1 Then
          If RoseApp.CurrentModel.GetSelectedCategories.GetAt(1).IsLoaded And _
           RoseApp.CurrentModel.GetSelectedCategories.GetAt(1).IsModifiable Then
           SortClasses.MenuState = rsEnabled
          Else
           SortClasses.MenuState = rsDisabled
          End If
          
        End If
    End If
    OnEnableContextMenuItems = True
End Function

Public Function OnSelectedContextMenuItem(RoseApp As RoseApplication, _
                                   internalName As String) As Boolean
  Dim theCat As RoseCategory
  Dim store As New RoseClassCollection
  Dim catClasses As RoseClassCollection
  Dim aClass As RoseClass
  Dim tempCat As RoseCategory
  Dim i, m, pos As Integer
  Dim worked As Boolean
  
  If Left(internalName, 11) = "SortClasses" Then
      
   If RoseApp.CurrentModel.GetSelectedCategories.Count = 1 Then
    ' RoseApp.WriteErrorLog ("onSelected")
     Set theCat = RoseApp.CurrentModel.GetSelectedCategories.GetAt(1)
     'RoseApp.WriteErrorLog ("Cat: " + theCat.GetQualifiedName)
     Set catClasses = theCat.Classes
     
     If catClasses.Count >= 2 Then
     
       RoseApp.WriteErrorLog "[Alphabetiser] -- Package: " & theCat.GetQualifiedName
       'make a temporary category
       '-> directly under model root package
       'Set tempCat = RoseApp.CurrentModel.RootCategory.AddCategory("temp")
        'under the selected package
       Set tempCat = theCat.AddCategory("temp")
       
      'out the names in the array we will use to alphabetize
       ReDim NamesArray(1 To catClasses.Count)
       
       For i = 1 To catClasses.Count
            NamesArray(i) = catClasses.GetAt(i).Name
       Next i

       'move the classes to the temporary category
       While catClasses.Count > 0
         Set aClass = catClasses.GetAt(1)
         tempCat.RelocateClass aClass
       Wend
       
       Call SelectionSortStrings(NamesArray)
      
       'put the classes back in their order in the name array
       Dim theClass As RoseClass
       
       For m = 1 To UBound(NamesArray)
         pos = tempCat.Classes.FindFirst(NamesArray(m))
         Set theClass = tempCat.Classes.GetAt(pos)
         theCat.RelocateClass theClass
       Next m
    
       'destroy the temporary category
       'when temp category was added under model root
       'worked = RoseApp.CurrentModel.RootCategory.DeleteCategory(tempCat)
       'when temp category was added under selected package
       worked = theCat.DeleteCategory(tempCat)

       RoseApp.WriteErrorLog "[Alphabetiser] -- Done"
      End If
   End If
End If
OnSelectedContextMenuItem = True
End Function

Public Sub onActivate(RoseApp As RoseApplication)
    RoseApp.WriteErrorLog ("[Alphabetiser] -- OnActivate")
    Dim thisAddin As RoseAddIn
    Set thisAddin = RoseApp.AddInManager.AddIns.GetFirst("Alphabetiser")
    If Not thisAddin Is Nothing Then
        Dim tmpMenuItem As RoseContextMenuItem
        Set tmpMenuItem = thisAddin.AddContextMenuItem(rsPackage, "Separator", "")
        Set SortClasses = thisAddin.AddContextMenuItem(rsPackage, "Sort Package Classes", _
                                                       "SortClasses")
        Set tmpMenuItem = thisAddin.AddContextMenuItem(rsPackage, "endsubmenu", "")
    End If
End Sub

Public Sub OnAppInit(RoseApp As RoseApplication)
   'RoseApp.WriteErrorLog ("[Alphabetiser] -- OnAppIni]")
End Sub

Public Sub onDeactivate(RoseApp As RoseApplication)
    RoseApp.WriteErrorLog ("[Alphabetiser] -- OnDeactivate")
    Set SortClasses = Nothing
End Sub
'--------------------------------------------<END of Alphabetiser.cls>----------------------------------
